<template>
  <nav class="navbar">
    <div class="navbar_item navbar_titulo">

      <div class="navbar_titulo_container">
        <fa icon="calendar" class=" navbar_titulo_icone"/>
        <div class=" navbar_titulo_texto"> DBZ </div>
      </div>

      <div v-show="isOnCourse && isAuthenticated && isOnIndex"
        class="navbar_titulo_button"
        @click="savePlan()">
        &#9989; Salvar
      </div>
    </div>

    <div class="navbar_item navbar_semestres">
      <div class="navbar_semestres_titulo">Semestres: </div>
      <div v-for="semestre of Semestres"
        class="navbar_semestres_item"
        :id="semestre"
        :style="renderSelected(semestre)"
        :key="semestre"
        @click="select($event)">
        {{semestre}}
      </div>

      <div class="navbar_semestres_button">
        +
      </div>
    </div>

  </nav>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  data() {
    return {
      selected: "Geral",
      Semestres: ["Geral", "1º", "2º", "3º", "4º", "5º", "6º", "7º", "8º"]
    };
  },

  methods: {
    select(event) {
      this.selected = `${event.target.id}`;

      this.$store.commit("setSelectedSemester", {
        selectedSemester: this.selected
      });

      if (this.selected !== "Geral") {
        this.$router.push("/plano");

        let payload = {
          ano_sem: this.getSemesterNumber,
          nusp_aln: this.getNusp
        };

        this.$store.dispatch("setSemester", {
          type: "aprovadas",
          name: "approved",
          payload,
          setter: "Approved"
        });

        payload["n_plan"] = this.getPlanNumber;
        this.$store.dispatch("setSemester", {
          type: "planejadas",
          name: "planned",
          payload,
          setter: "Planned"
        });
      } else {
        this.$router.push("/");
      }
    },

    async savePlan() {
      await this.$store.dispatch("commitPlan");
      await this.$store.dispatch("getPlans");
    },

    renderSelected(element) {
      if (element === this.selected)
        return `color: #F5F5F5; background: #3F51B5;`;
    }
  },

  computed: {
    ...mapGetters([
      "isAuthenticated",
      "isOnCourse",
      "isOnIndex",
      "getNusp",
      "getSemesterNumber",
      "getPlanNumber"
    ])
  }
};
</script>


<style lang="scss">
.navbar {
  grid-area: navbar;
  align-self: stretch;

  display: flex;
  flex-flow: column nowrap;
  justify-content: center;
  align-items: flex-start;
}

.navbar_item {
  padding-left: 0.5em;
  align-self: stretch;
}

.navbar_titulo {
  display: flex;
  flex-flow: row nowrap;
  justify-content: space-between;
  align-items: center;

  font-size: 2em;

  background: $primary-color;
  color: $light-color;

  padding: 0.35em 0;
}

.navbar_titulo_container {
  display: flex;
  flex-flow: row nowrap;
}

.navbar_titulo_icone {
  grid-area: texto;
}

.navbar_titulo_texto {
  grid-area: texto;
  justify-self: left;
  padding-left: 0.3em;
}

.navbar_titulo_button {
  grid-area: button;

  margin: 0 0.5rem;
  padding: 0.5rem;
  border-radius: 0.3rem;
  font-size: 16px;

  background: $secondary-color;
  color: $light-color;

  user-select: none;
  cursor: pointer;
}

.navbar_semestres {
  display: flex;
  flex-flow: row nowrap;
  justify-content: flex-start;
  align-items: center;

  background: $medium-color;
  color: $primary-color;
  padding: 1em 0 0 1em;
}

.navbar_semestres_titulo {
  user-select: none;
}

.navbar_semestres_item {
  background: $light-color;
  padding: 0.5em;
  margin-left: 0.5em;

  border-radius: 0.3em;

  user-select: none;
  cursor: pointer;
}

.navbar_semestres_button {
  margin-left: 0.5em;
  padding: 0.4em 0.7em;
  border-radius: 100%;

  background: $primary-color;
  color: $light-color;
  font-weight: bold;

  user-select: none;
  cursor: pointer;
}
</style>
